CREATE OR REPLACE PACKAGE BODY "HRM_SALARY_RULES" is

  g_salessalarycap number;

  procedure set_salessalarycap( p_salessalarycap in number)
  is
  begin
    g_salessalarycap:= p_salessalarycap;
  end set_salessalarycap;

  function verify_salary_raise( p_job in varchar2, p_old_salary in number, p_new_salary in number)
  return boolean
  is
  begin 
    -- among a lot of other tests...
    if instr(lower(p_job),'sales') > 0
    then
      if (p_new_salary - p_old_salary)/p_old_salary > g_salessalarycap/100
      then
        emailer.send_email
        ( p_sender => 'jellema@amis.nl'
        , p_recipient => 'jellema@amis.nl'
        , p_subject => 'Attempt to violate Salary Rule'
        , p_message => 'Someone tried to update a salary of a '||p_job
                     ||' from '||p_old_salary||' to '||p_new_salary
                     ||'  which is illegal!'
        );
        return false;
      end if;
    end if;
    return true;
  end verify_salary_raise;

  function verify_job_change( p_old_job in varchar2, p_new_job in varchar2)
  return boolean
  is
  begin
    if p_old_job in ('SALESMAN','CLERK') and p_new_job in ('MANAGER','PRESIDENT')
    then
      return false;
    end if;
    return true;    
  end verify_job_change;
  
end HRM_SALARY_RULES;
